
public class HeapSort  extends SortingAlgorithm {
  
  
  private void dropHeap( int i, int n, int x, int[] heap ) {
    
    int j = 2 * i;
    boolean found = false;
    
    while ( !found && (j < n) ) {
      
      if ( heap[j-1] < heap[j] ) {
        j = j + 1;
      }
      if ( x < heap[j-1] ) {
        heap[i-1] = heap[j-1];
        i = j;
        j = 2 * j;
      } else {
        heap[i-1] = x;
        found = true;
      }}
    if ( !found ) {
      
      if ( j == n ) {
        if ( x < heap[j-1] ) {
          heap[i-1] = heap[j-1];
          heap[j-1] = x;
        } else {
          heap[i-1] = x;
        }
      } else {
        heap[i-1] = x;
      }}
  }
  
  
  private void buildHeap( int[] heap ) {
    
    int n = heap.length;
    int u = 1;
    do {
      u = 2 * u;
    } while ( u <= n );
    u = u / 2;
    for ( int i=u/2; i<=(n-1)/2; i++ ) {
      int j = 2 * i;
      if ( heap[j-1] < heap[j] ) {
        j = j + 1;
      }
      if ( heap[i-1] < heap[j-1] ) {
        int x = heap[j-1];
        heap[j-1] = heap[i-1];
        heap[i-1] = x;
      }
    }
    if ( n % 2 == 0 ) {
      int i = n / 2;
      if ( heap[i-1] < heap[n-1] ) {
        int x = heap[n-1];
        heap[n-1] = heap[i-1];
        heap[i-1] = x;
      }}
    while ( u > 2 ) {
      u = u / 2;
      for ( int i=u/2; i<u; i++ ) {
        dropHeap( i, heap.length, heap[i-1], heap );
      }}
  }
  
  
  // Schema di ordinamento "Heap Sort"
  
  public void sort( int[] seq ) {
    
    int n = seq.length;
    
    buildHeap( seq );
    
    for ( int k=n; k>2; k-- ) {
      
      int z = seq[0];
      dropHeap( 1, k-1, seq[k-1], seq );
      seq[k-1] = z;
    }
    int z = seq[0];
    seq[0] = seq[1];
    seq[1] = z;
  }
  
  
}  // class HeapSort

